#ifndef _H_58AC74506444AD1CF5AE84C3BB82CFD0_SrrDebug5_DCPS_H_
#define _H_58AC74506444AD1CF5AE84C3BB82CFD0_SrrDebug5_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrDebug5_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrDebug5_TypeSupportInterface;

            typedef SrrDebug5_TypeSupportInterface * SrrDebug5_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug5_TypeSupportInterface> SrrDebug5_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrDebug5_TypeSupportInterface> SrrDebug5_TypeSupportInterface_out;


            class SrrDebug5_DataWriter;

            typedef SrrDebug5_DataWriter * SrrDebug5_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug5_DataWriter> SrrDebug5_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrDebug5_DataWriter> SrrDebug5_DataWriter_out;


            class SrrDebug5_DataReader;

            typedef SrrDebug5_DataReader * SrrDebug5_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug5_DataReader> SrrDebug5_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrDebug5_DataReader> SrrDebug5_DataReader_out;


            class SrrDebug5_DataReaderView;

            typedef SrrDebug5_DataReaderView * SrrDebug5_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug5_DataReaderView> SrrDebug5_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrDebug5_DataReaderView> SrrDebug5_DataReaderView_out;

            struct SrrDebug5_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrDebug5_, struct SrrDebug5_Seq_uniq_> SrrDebug5_Seq;
            typedef DDS_DCPSSequence_var < SrrDebug5_Seq> SrrDebug5_Seq_var;
            typedef DDS_DCPSSequence_out < SrrDebug5_Seq> SrrDebug5_Seq_out;

            class  SrrDebug5_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrDebug5_TypeSupportInterface_ptr _ptr_type;
                typedef SrrDebug5_TypeSupportInterface_var _var_type;

                static SrrDebug5_TypeSupportInterface_ptr _duplicate (SrrDebug5_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug5_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug5_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug5_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug5_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrDebug5_TypeSupportInterface () {};
                ~SrrDebug5_TypeSupportInterface () {};
            private:
                SrrDebug5_TypeSupportInterface (const SrrDebug5_TypeSupportInterface &);
                SrrDebug5_TypeSupportInterface & operator = (const SrrDebug5_TypeSupportInterface &);
            };

            class  SrrDebug5_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrDebug5_DataWriter_ptr _ptr_type;
                typedef SrrDebug5_DataWriter_var _var_type;

                static SrrDebug5_DataWriter_ptr _duplicate (SrrDebug5_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug5_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug5_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrDebug5_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrDebug5_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrDebug5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrDebug5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrDebug5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrDebug5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrDebug5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrDebug5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrDebug5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrDebug5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrDebug5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug5_& instance_data) = 0;

            protected:
                SrrDebug5_DataWriter () {};
                ~SrrDebug5_DataWriter () {};
            private:
                SrrDebug5_DataWriter (const SrrDebug5_DataWriter &);
                SrrDebug5_DataWriter & operator = (const SrrDebug5_DataWriter &);
            };

            class  SrrDebug5_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrDebug5_DataReader_ptr _ptr_type;
                typedef SrrDebug5_DataReader_var _var_type;

                static SrrDebug5_DataReader_ptr _duplicate (SrrDebug5_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug5_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug5_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug5_& instance) = 0;

            protected:
                SrrDebug5_DataReader () {};
                ~SrrDebug5_DataReader () {};
            private:
                SrrDebug5_DataReader (const SrrDebug5_DataReader &);
                SrrDebug5_DataReader & operator = (const SrrDebug5_DataReader &);
            };

            class  SrrDebug5_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrDebug5_DataReaderView_ptr _ptr_type;
                typedef SrrDebug5_DataReaderView_var _var_type;

                static SrrDebug5_DataReaderView_ptr _duplicate (SrrDebug5_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug5_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug5_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug5_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug5_& instance) = 0;

            protected:
                SrrDebug5_DataReaderView () {};
                ~SrrDebug5_DataReaderView () {};
            private:
                SrrDebug5_DataReaderView (const SrrDebug5_DataReaderView &);
                SrrDebug5_DataReaderView & operator = (const SrrDebug5_DataReaderView &);
            };
        }

    }

}

#endif
