#ifndef _H_5044C3A784FF94A4B88CDC14115AB9DE_SrrFeatureAlert_DCPS_H_
#define _H_5044C3A784FF94A4B88CDC14115AB9DE_SrrFeatureAlert_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrFeatureAlert_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrFeatureAlert_TypeSupportInterface;

            typedef SrrFeatureAlert_TypeSupportInterface * SrrFeatureAlert_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureAlert_TypeSupportInterface> SrrFeatureAlert_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrFeatureAlert_TypeSupportInterface> SrrFeatureAlert_TypeSupportInterface_out;


            class SrrFeatureAlert_DataWriter;

            typedef SrrFeatureAlert_DataWriter * SrrFeatureAlert_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureAlert_DataWriter> SrrFeatureAlert_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrFeatureAlert_DataWriter> SrrFeatureAlert_DataWriter_out;


            class SrrFeatureAlert_DataReader;

            typedef SrrFeatureAlert_DataReader * SrrFeatureAlert_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureAlert_DataReader> SrrFeatureAlert_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrFeatureAlert_DataReader> SrrFeatureAlert_DataReader_out;


            class SrrFeatureAlert_DataReaderView;

            typedef SrrFeatureAlert_DataReaderView * SrrFeatureAlert_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureAlert_DataReaderView> SrrFeatureAlert_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrFeatureAlert_DataReaderView> SrrFeatureAlert_DataReaderView_out;

            struct SrrFeatureAlert_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrFeatureAlert_, struct SrrFeatureAlert_Seq_uniq_> SrrFeatureAlert_Seq;
            typedef DDS_DCPSSequence_var < SrrFeatureAlert_Seq> SrrFeatureAlert_Seq_var;
            typedef DDS_DCPSSequence_out < SrrFeatureAlert_Seq> SrrFeatureAlert_Seq_out;

            class  SrrFeatureAlert_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrFeatureAlert_TypeSupportInterface_ptr _ptr_type;
                typedef SrrFeatureAlert_TypeSupportInterface_var _var_type;

                static SrrFeatureAlert_TypeSupportInterface_ptr _duplicate (SrrFeatureAlert_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureAlert_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureAlert_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrFeatureAlert_TypeSupportInterface () {};
                ~SrrFeatureAlert_TypeSupportInterface () {};
            private:
                SrrFeatureAlert_TypeSupportInterface (const SrrFeatureAlert_TypeSupportInterface &);
                SrrFeatureAlert_TypeSupportInterface & operator = (const SrrFeatureAlert_TypeSupportInterface &);
            };

            class  SrrFeatureAlert_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrFeatureAlert_DataWriter_ptr _ptr_type;
                typedef SrrFeatureAlert_DataWriter_var _var_type;

                static SrrFeatureAlert_DataWriter_ptr _duplicate (SrrFeatureAlert_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureAlert_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureAlert_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrFeatureAlert_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrFeatureAlert_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrFeatureAlert_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrFeatureAlert_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrFeatureAlert_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrFeatureAlert_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrFeatureAlert_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrFeatureAlert_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrFeatureAlert_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrFeatureAlert_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrFeatureAlert_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureAlert_& instance_data) = 0;

            protected:
                SrrFeatureAlert_DataWriter () {};
                ~SrrFeatureAlert_DataWriter () {};
            private:
                SrrFeatureAlert_DataWriter (const SrrFeatureAlert_DataWriter &);
                SrrFeatureAlert_DataWriter & operator = (const SrrFeatureAlert_DataWriter &);
            };

            class  SrrFeatureAlert_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrFeatureAlert_DataReader_ptr _ptr_type;
                typedef SrrFeatureAlert_DataReader_var _var_type;

                static SrrFeatureAlert_DataReader_ptr _duplicate (SrrFeatureAlert_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureAlert_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureAlert_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrFeatureAlert_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrFeatureAlert_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrFeatureAlert_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureAlert_& instance) = 0;

            protected:
                SrrFeatureAlert_DataReader () {};
                ~SrrFeatureAlert_DataReader () {};
            private:
                SrrFeatureAlert_DataReader (const SrrFeatureAlert_DataReader &);
                SrrFeatureAlert_DataReader & operator = (const SrrFeatureAlert_DataReader &);
            };

            class  SrrFeatureAlert_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrFeatureAlert_DataReaderView_ptr _ptr_type;
                typedef SrrFeatureAlert_DataReaderView_var _var_type;

                static SrrFeatureAlert_DataReaderView_ptr _duplicate (SrrFeatureAlert_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureAlert_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureAlert_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureAlert_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrFeatureAlert_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrFeatureAlert_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrFeatureAlert_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrFeatureAlert_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureAlert_& instance) = 0;

            protected:
                SrrFeatureAlert_DataReaderView () {};
                ~SrrFeatureAlert_DataReaderView () {};
            private:
                SrrFeatureAlert_DataReaderView (const SrrFeatureAlert_DataReaderView &);
                SrrFeatureAlert_DataReaderView & operator = (const SrrFeatureAlert_DataReaderView &);
            };
        }

    }

}

#endif
