#ifndef _H_E6CD94DBC9EF17FE774018B4A2C5303A_SrrFeatureSwVersion_DCPS_H_
#define _H_E6CD94DBC9EF17FE774018B4A2C5303A_SrrFeatureSwVersion_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrFeatureSwVersion_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrFeatureSwVersion_TypeSupportInterface;

            typedef SrrFeatureSwVersion_TypeSupportInterface * SrrFeatureSwVersion_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureSwVersion_TypeSupportInterface> SrrFeatureSwVersion_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrFeatureSwVersion_TypeSupportInterface> SrrFeatureSwVersion_TypeSupportInterface_out;


            class SrrFeatureSwVersion_DataWriter;

            typedef SrrFeatureSwVersion_DataWriter * SrrFeatureSwVersion_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureSwVersion_DataWriter> SrrFeatureSwVersion_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrFeatureSwVersion_DataWriter> SrrFeatureSwVersion_DataWriter_out;


            class SrrFeatureSwVersion_DataReader;

            typedef SrrFeatureSwVersion_DataReader * SrrFeatureSwVersion_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureSwVersion_DataReader> SrrFeatureSwVersion_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrFeatureSwVersion_DataReader> SrrFeatureSwVersion_DataReader_out;


            class SrrFeatureSwVersion_DataReaderView;

            typedef SrrFeatureSwVersion_DataReaderView * SrrFeatureSwVersion_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrFeatureSwVersion_DataReaderView> SrrFeatureSwVersion_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrFeatureSwVersion_DataReaderView> SrrFeatureSwVersion_DataReaderView_out;

            struct SrrFeatureSwVersion_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrFeatureSwVersion_, struct SrrFeatureSwVersion_Seq_uniq_> SrrFeatureSwVersion_Seq;
            typedef DDS_DCPSSequence_var < SrrFeatureSwVersion_Seq> SrrFeatureSwVersion_Seq_var;
            typedef DDS_DCPSSequence_out < SrrFeatureSwVersion_Seq> SrrFeatureSwVersion_Seq_out;

            class  SrrFeatureSwVersion_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrFeatureSwVersion_TypeSupportInterface_ptr _ptr_type;
                typedef SrrFeatureSwVersion_TypeSupportInterface_var _var_type;

                static SrrFeatureSwVersion_TypeSupportInterface_ptr _duplicate (SrrFeatureSwVersion_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureSwVersion_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureSwVersion_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrFeatureSwVersion_TypeSupportInterface () {};
                ~SrrFeatureSwVersion_TypeSupportInterface () {};
            private:
                SrrFeatureSwVersion_TypeSupportInterface (const SrrFeatureSwVersion_TypeSupportInterface &);
                SrrFeatureSwVersion_TypeSupportInterface & operator = (const SrrFeatureSwVersion_TypeSupportInterface &);
            };

            class  SrrFeatureSwVersion_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrFeatureSwVersion_DataWriter_ptr _ptr_type;
                typedef SrrFeatureSwVersion_DataWriter_var _var_type;

                static SrrFeatureSwVersion_DataWriter_ptr _duplicate (SrrFeatureSwVersion_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureSwVersion_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureSwVersion_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrFeatureSwVersion_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrFeatureSwVersion_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrFeatureSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrFeatureSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureSwVersion_& instance_data) = 0;

            protected:
                SrrFeatureSwVersion_DataWriter () {};
                ~SrrFeatureSwVersion_DataWriter () {};
            private:
                SrrFeatureSwVersion_DataWriter (const SrrFeatureSwVersion_DataWriter &);
                SrrFeatureSwVersion_DataWriter & operator = (const SrrFeatureSwVersion_DataWriter &);
            };

            class  SrrFeatureSwVersion_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrFeatureSwVersion_DataReader_ptr _ptr_type;
                typedef SrrFeatureSwVersion_DataReader_var _var_type;

                static SrrFeatureSwVersion_DataReader_ptr _duplicate (SrrFeatureSwVersion_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureSwVersion_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureSwVersion_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrFeatureSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrFeatureSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrFeatureSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureSwVersion_& instance) = 0;

            protected:
                SrrFeatureSwVersion_DataReader () {};
                ~SrrFeatureSwVersion_DataReader () {};
            private:
                SrrFeatureSwVersion_DataReader (const SrrFeatureSwVersion_DataReader &);
                SrrFeatureSwVersion_DataReader & operator = (const SrrFeatureSwVersion_DataReader &);
            };

            class  SrrFeatureSwVersion_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrFeatureSwVersion_DataReaderView_ptr _ptr_type;
                typedef SrrFeatureSwVersion_DataReaderView_var _var_type;

                static SrrFeatureSwVersion_DataReaderView_ptr _duplicate (SrrFeatureSwVersion_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrFeatureSwVersion_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrFeatureSwVersion_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrFeatureSwVersion_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrFeatureSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrFeatureSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrFeatureSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrFeatureSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrFeatureSwVersion_& instance) = 0;

            protected:
                SrrFeatureSwVersion_DataReaderView () {};
                ~SrrFeatureSwVersion_DataReaderView () {};
            private:
                SrrFeatureSwVersion_DataReaderView (const SrrFeatureSwVersion_DataReaderView &);
                SrrFeatureSwVersion_DataReaderView & operator = (const SrrFeatureSwVersion_DataReaderView &);
            };
        }

    }

}

#endif
