#ifndef _H_3C37ED23EEE115A5B61BADDFC8061F9E_SrrStatus1_DCPS_H_
#define _H_3C37ED23EEE115A5B61BADDFC8061F9E_SrrStatus1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrStatus1_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrStatus1_TypeSupportInterface;

            typedef SrrStatus1_TypeSupportInterface * SrrStatus1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus1_TypeSupportInterface> SrrStatus1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrStatus1_TypeSupportInterface> SrrStatus1_TypeSupportInterface_out;


            class SrrStatus1_DataWriter;

            typedef SrrStatus1_DataWriter * SrrStatus1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus1_DataWriter> SrrStatus1_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrStatus1_DataWriter> SrrStatus1_DataWriter_out;


            class SrrStatus1_DataReader;

            typedef SrrStatus1_DataReader * SrrStatus1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus1_DataReader> SrrStatus1_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrStatus1_DataReader> SrrStatus1_DataReader_out;


            class SrrStatus1_DataReaderView;

            typedef SrrStatus1_DataReaderView * SrrStatus1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus1_DataReaderView> SrrStatus1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrStatus1_DataReaderView> SrrStatus1_DataReaderView_out;

            struct SrrStatus1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrStatus1_, struct SrrStatus1_Seq_uniq_> SrrStatus1_Seq;
            typedef DDS_DCPSSequence_var < SrrStatus1_Seq> SrrStatus1_Seq_var;
            typedef DDS_DCPSSequence_out < SrrStatus1_Seq> SrrStatus1_Seq_out;

            class  SrrStatus1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrStatus1_TypeSupportInterface_ptr _ptr_type;
                typedef SrrStatus1_TypeSupportInterface_var _var_type;

                static SrrStatus1_TypeSupportInterface_ptr _duplicate (SrrStatus1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrStatus1_TypeSupportInterface () {};
                ~SrrStatus1_TypeSupportInterface () {};
            private:
                SrrStatus1_TypeSupportInterface (const SrrStatus1_TypeSupportInterface &);
                SrrStatus1_TypeSupportInterface & operator = (const SrrStatus1_TypeSupportInterface &);
            };

            class  SrrStatus1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrStatus1_DataWriter_ptr _ptr_type;
                typedef SrrStatus1_DataWriter_var _var_type;

                static SrrStatus1_DataWriter_ptr _duplicate (SrrStatus1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrStatus1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrStatus1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus1_& instance_data) = 0;

            protected:
                SrrStatus1_DataWriter () {};
                ~SrrStatus1_DataWriter () {};
            private:
                SrrStatus1_DataWriter (const SrrStatus1_DataWriter &);
                SrrStatus1_DataWriter & operator = (const SrrStatus1_DataWriter &);
            };

            class  SrrStatus1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrStatus1_DataReader_ptr _ptr_type;
                typedef SrrStatus1_DataReader_var _var_type;

                static SrrStatus1_DataReader_ptr _duplicate (SrrStatus1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus1_& instance) = 0;

            protected:
                SrrStatus1_DataReader () {};
                ~SrrStatus1_DataReader () {};
            private:
                SrrStatus1_DataReader (const SrrStatus1_DataReader &);
                SrrStatus1_DataReader & operator = (const SrrStatus1_DataReader &);
            };

            class  SrrStatus1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrStatus1_DataReaderView_ptr _ptr_type;
                typedef SrrStatus1_DataReaderView_var _var_type;

                static SrrStatus1_DataReaderView_ptr _duplicate (SrrStatus1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus1_& instance) = 0;

            protected:
                SrrStatus1_DataReaderView () {};
                ~SrrStatus1_DataReaderView () {};
            private:
                SrrStatus1_DataReaderView (const SrrStatus1_DataReaderView &);
                SrrStatus1_DataReaderView & operator = (const SrrStatus1_DataReaderView &);
            };
        }

    }

}

#endif
