#ifndef _H_BC9DAA57221BAC4DB255319F0CF71DC0_SrrStatus3_DCPS_H_
#define _H_BC9DAA57221BAC4DB255319F0CF71DC0_SrrStatus3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrStatus3_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrStatus3_TypeSupportInterface;

            typedef SrrStatus3_TypeSupportInterface * SrrStatus3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus3_TypeSupportInterface> SrrStatus3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrStatus3_TypeSupportInterface> SrrStatus3_TypeSupportInterface_out;


            class SrrStatus3_DataWriter;

            typedef SrrStatus3_DataWriter * SrrStatus3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus3_DataWriter> SrrStatus3_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrStatus3_DataWriter> SrrStatus3_DataWriter_out;


            class SrrStatus3_DataReader;

            typedef SrrStatus3_DataReader * SrrStatus3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus3_DataReader> SrrStatus3_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrStatus3_DataReader> SrrStatus3_DataReader_out;


            class SrrStatus3_DataReaderView;

            typedef SrrStatus3_DataReaderView * SrrStatus3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus3_DataReaderView> SrrStatus3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrStatus3_DataReaderView> SrrStatus3_DataReaderView_out;

            struct SrrStatus3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrStatus3_, struct SrrStatus3_Seq_uniq_> SrrStatus3_Seq;
            typedef DDS_DCPSSequence_var < SrrStatus3_Seq> SrrStatus3_Seq_var;
            typedef DDS_DCPSSequence_out < SrrStatus3_Seq> SrrStatus3_Seq_out;

            class  SrrStatus3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrStatus3_TypeSupportInterface_ptr _ptr_type;
                typedef SrrStatus3_TypeSupportInterface_var _var_type;

                static SrrStatus3_TypeSupportInterface_ptr _duplicate (SrrStatus3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrStatus3_TypeSupportInterface () {};
                ~SrrStatus3_TypeSupportInterface () {};
            private:
                SrrStatus3_TypeSupportInterface (const SrrStatus3_TypeSupportInterface &);
                SrrStatus3_TypeSupportInterface & operator = (const SrrStatus3_TypeSupportInterface &);
            };

            class  SrrStatus3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrStatus3_DataWriter_ptr _ptr_type;
                typedef SrrStatus3_DataWriter_var _var_type;

                static SrrStatus3_DataWriter_ptr _duplicate (SrrStatus3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrStatus3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrStatus3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus3_& instance_data) = 0;

            protected:
                SrrStatus3_DataWriter () {};
                ~SrrStatus3_DataWriter () {};
            private:
                SrrStatus3_DataWriter (const SrrStatus3_DataWriter &);
                SrrStatus3_DataWriter & operator = (const SrrStatus3_DataWriter &);
            };

            class  SrrStatus3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrStatus3_DataReader_ptr _ptr_type;
                typedef SrrStatus3_DataReader_var _var_type;

                static SrrStatus3_DataReader_ptr _duplicate (SrrStatus3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus3_& instance) = 0;

            protected:
                SrrStatus3_DataReader () {};
                ~SrrStatus3_DataReader () {};
            private:
                SrrStatus3_DataReader (const SrrStatus3_DataReader &);
                SrrStatus3_DataReader & operator = (const SrrStatus3_DataReader &);
            };

            class  SrrStatus3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrStatus3_DataReaderView_ptr _ptr_type;
                typedef SrrStatus3_DataReaderView_var _var_type;

                static SrrStatus3_DataReaderView_ptr _duplicate (SrrStatus3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus3_& instance) = 0;

            protected:
                SrrStatus3_DataReaderView () {};
                ~SrrStatus3_DataReaderView () {};
            private:
                SrrStatus3_DataReaderView (const SrrStatus3_DataReaderView &);
                SrrStatus3_DataReaderView & operator = (const SrrStatus3_DataReaderView &);
            };
        }

    }

}

#endif
