#ifndef _H_922C575655D5C0D638C8F3F199AB0313_SrrStatus5__H_
#define _H_922C575655D5C0D638C8F3F199AB0313_SrrStatus5__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SrrStatus5_Constants
            {
                const ::DDS::Octet CAN_TX_YAW_RATE_REF_QF_UNDEFINED_ = 0;

                const ::DDS::Octet CAN_TX_YAW_RATE_REF_QF_TEMP_UNDEFINED_ = 1;

                const ::DDS::Octet CAN_TX_YAW_RATE_REF_QF_NOT_ACCURATE_ = 2;

                const ::DDS::Octet CAN_TX_YAW_RATE_REF_QF_ACCURATE_ = 3;

                const ::DDS::Octet CAN_TX_YAW_RATE_RAW_QF_UNDEFINED_ = 0;

                const ::DDS::Octet CAN_TX_YAW_RATE_RAW_QF_TEMP_UNDEFINED_ = 1;

                const ::DDS::Octet CAN_TX_YAW_RATE_RAW_QF_NOT_ACCURATE_ = 2;

                const ::DDS::Octet CAN_TX_YAW_RATE_RAW_QF_ACCURATE_ = 3;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_CONFIGURATION_ = 0;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_STARTUP_ = 1;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_RUNNING_ = 2;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_BLOCKED_ = 3;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_FAULTY_ = 4;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_SHUTDOWN_ = 5;

                const ::DDS::Octet CAN_TX_SYSTEM_STATUS_HOT_ = 6;

            }

            struct  SrrStatus5_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean disable_auto_align_;
                ::DDS::Octet can_tx_yaw_rate_ref_qf_;
                ::DDS::Octet can_tx_yaw_rate_raw_qf_;
                ::DDS::Float can_tx_yaw_rate_reference_;
                ::DDS::Float can_tx_yaw_rate_raw_;
                ::DDS::Octet can_tx_system_status_;
                ::DDS::Short can_tx_outside_temperature_;
                ::DDS::Boolean can_blockage_mnr_blocked_;
                ::DDS::Boolean can_blockage_bb_blocked_;
                ::DDS::Boolean can_blockage_radar_blocked_;
                ::DDS::Boolean can_td_blocked_;
                ::DDS::Boolean radar_tx_power_error_;
                ::DDS::Boolean radar_lo_power_error_;
                ::DDS::Boolean radar_data_sync_error_;
                ::DDS::Boolean linearizer_spi_transfer_error_;
                ::DDS::Boolean saturated_tuning_freq_error_;
                ::DDS::Boolean rtn_spi_transfer_error_;
                ::DDS::Boolean rrn_spi_transfer_error_;
                ::DDS::Boolean video_port_capture_error_;
                ::DDS::Boolean vertical_misalignment_error_;
                ::DDS::Boolean tx_temperature_fault_;
                ::DDS::Boolean transmitter_id_error_;
                ::DDS::Boolean dsp_unit_cal_checksum_error_;
                ::DDS::Boolean dsp_unit_cal_block_chcksm_error_;
                ::DDS::Boolean dsp_tuning_sensitivity_error_;
                ::DDS::Boolean dsp_loop_overrun_error_;
                ::DDS::Boolean adc_spi_transfer_error_;
            };

            typedef DDS_DCPSStruct_var<SrrStatus5_> SrrStatus5__var;
            typedef DDS_DCPSStruct_out < SrrStatus5_> SrrStatus5__out;

        }

    }

}

#endif /* _H_922C575655D5C0D638C8F3F199AB0313_SrrStatus5__H_ */
