#ifndef _H_922C575655D5C0D638C8F3F199AB0313_SrrStatus5_DCPS_H_
#define _H_922C575655D5C0D638C8F3F199AB0313_SrrStatus5_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrStatus5_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrStatus5_TypeSupportInterface;

            typedef SrrStatus5_TypeSupportInterface * SrrStatus5_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus5_TypeSupportInterface> SrrStatus5_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrStatus5_TypeSupportInterface> SrrStatus5_TypeSupportInterface_out;


            class SrrStatus5_DataWriter;

            typedef SrrStatus5_DataWriter * SrrStatus5_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus5_DataWriter> SrrStatus5_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrStatus5_DataWriter> SrrStatus5_DataWriter_out;


            class SrrStatus5_DataReader;

            typedef SrrStatus5_DataReader * SrrStatus5_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus5_DataReader> SrrStatus5_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrStatus5_DataReader> SrrStatus5_DataReader_out;


            class SrrStatus5_DataReaderView;

            typedef SrrStatus5_DataReaderView * SrrStatus5_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus5_DataReaderView> SrrStatus5_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrStatus5_DataReaderView> SrrStatus5_DataReaderView_out;

            struct SrrStatus5_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrStatus5_, struct SrrStatus5_Seq_uniq_> SrrStatus5_Seq;
            typedef DDS_DCPSSequence_var < SrrStatus5_Seq> SrrStatus5_Seq_var;
            typedef DDS_DCPSSequence_out < SrrStatus5_Seq> SrrStatus5_Seq_out;

            class  SrrStatus5_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrStatus5_TypeSupportInterface_ptr _ptr_type;
                typedef SrrStatus5_TypeSupportInterface_var _var_type;

                static SrrStatus5_TypeSupportInterface_ptr _duplicate (SrrStatus5_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus5_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus5_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus5_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus5_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrStatus5_TypeSupportInterface () {};
                ~SrrStatus5_TypeSupportInterface () {};
            private:
                SrrStatus5_TypeSupportInterface (const SrrStatus5_TypeSupportInterface &);
                SrrStatus5_TypeSupportInterface & operator = (const SrrStatus5_TypeSupportInterface &);
            };

            class  SrrStatus5_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrStatus5_DataWriter_ptr _ptr_type;
                typedef SrrStatus5_DataWriter_var _var_type;

                static SrrStatus5_DataWriter_ptr _duplicate (SrrStatus5_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus5_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus5_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrStatus5_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrStatus5_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrStatus5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrStatus5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrStatus5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrStatus5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrStatus5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrStatus5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrStatus5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrStatus5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrStatus5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus5_& instance_data) = 0;

            protected:
                SrrStatus5_DataWriter () {};
                ~SrrStatus5_DataWriter () {};
            private:
                SrrStatus5_DataWriter (const SrrStatus5_DataWriter &);
                SrrStatus5_DataWriter & operator = (const SrrStatus5_DataWriter &);
            };

            class  SrrStatus5_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrStatus5_DataReader_ptr _ptr_type;
                typedef SrrStatus5_DataReader_var _var_type;

                static SrrStatus5_DataReader_ptr _duplicate (SrrStatus5_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus5_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus5_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus5_& instance) = 0;

            protected:
                SrrStatus5_DataReader () {};
                ~SrrStatus5_DataReader () {};
            private:
                SrrStatus5_DataReader (const SrrStatus5_DataReader &);
                SrrStatus5_DataReader & operator = (const SrrStatus5_DataReader &);
            };

            class  SrrStatus5_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrStatus5_DataReaderView_ptr _ptr_type;
                typedef SrrStatus5_DataReaderView_var _var_type;

                static SrrStatus5_DataReaderView_ptr _duplicate (SrrStatus5_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus5_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus5_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus5_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus5_& instance) = 0;

            protected:
                SrrStatus5_DataReaderView () {};
                ~SrrStatus5_DataReaderView () {};
            private:
                SrrStatus5_DataReaderView (const SrrStatus5_DataReaderView &);
                SrrStatus5_DataReaderView & operator = (const SrrStatus5_DataReaderView &);
            };
        }

    }

}

#endif
