#ifndef _H_F53A1A7F4AD96DE74437A0800BC4C41C_SrrTrack_DCPS_H_
#define _H_F53A1A7F4AD96DE74437A0800BC4C41C_SrrTrack_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrTrack_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrTrack_TypeSupportInterface;

            typedef SrrTrack_TypeSupportInterface * SrrTrack_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrTrack_TypeSupportInterface> SrrTrack_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrTrack_TypeSupportInterface> SrrTrack_TypeSupportInterface_out;


            class SrrTrack_DataWriter;

            typedef SrrTrack_DataWriter * SrrTrack_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrTrack_DataWriter> SrrTrack_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrTrack_DataWriter> SrrTrack_DataWriter_out;


            class SrrTrack_DataReader;

            typedef SrrTrack_DataReader * SrrTrack_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrTrack_DataReader> SrrTrack_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrTrack_DataReader> SrrTrack_DataReader_out;


            class SrrTrack_DataReaderView;

            typedef SrrTrack_DataReaderView * SrrTrack_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrTrack_DataReaderView> SrrTrack_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrTrack_DataReaderView> SrrTrack_DataReaderView_out;

            struct SrrTrack_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrTrack_, struct SrrTrack_Seq_uniq_> SrrTrack_Seq;
            typedef DDS_DCPSSequence_var < SrrTrack_Seq> SrrTrack_Seq_var;
            typedef DDS_DCPSSequence_out < SrrTrack_Seq> SrrTrack_Seq_out;

            class  SrrTrack_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrTrack_TypeSupportInterface_ptr _ptr_type;
                typedef SrrTrack_TypeSupportInterface_var _var_type;

                static SrrTrack_TypeSupportInterface_ptr _duplicate (SrrTrack_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrTrack_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrTrack_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrTrack_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrTrack_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrTrack_TypeSupportInterface () {};
                ~SrrTrack_TypeSupportInterface () {};
            private:
                SrrTrack_TypeSupportInterface (const SrrTrack_TypeSupportInterface &);
                SrrTrack_TypeSupportInterface & operator = (const SrrTrack_TypeSupportInterface &);
            };

            class  SrrTrack_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrTrack_DataWriter_ptr _ptr_type;
                typedef SrrTrack_DataWriter_var _var_type;

                static SrrTrack_DataWriter_ptr _duplicate (SrrTrack_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrTrack_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrTrack_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrTrack_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrTrack_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrTrack_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrTrack_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrTrack_& instance_data) = 0;

            protected:
                SrrTrack_DataWriter () {};
                ~SrrTrack_DataWriter () {};
            private:
                SrrTrack_DataWriter (const SrrTrack_DataWriter &);
                SrrTrack_DataWriter & operator = (const SrrTrack_DataWriter &);
            };

            class  SrrTrack_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrTrack_DataReader_ptr _ptr_type;
                typedef SrrTrack_DataReader_var _var_type;

                static SrrTrack_DataReader_ptr _duplicate (SrrTrack_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrTrack_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrTrack_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrTrack_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrTrack_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrTrack_& instance) = 0;

            protected:
                SrrTrack_DataReader () {};
                ~SrrTrack_DataReader () {};
            private:
                SrrTrack_DataReader (const SrrTrack_DataReader &);
                SrrTrack_DataReader & operator = (const SrrTrack_DataReader &);
            };

            class  SrrTrack_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrTrack_DataReaderView_ptr _ptr_type;
                typedef SrrTrack_DataReaderView_var _var_type;

                static SrrTrack_DataReaderView_ptr _duplicate (SrrTrack_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrTrack_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrTrack_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrTrack_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrTrack_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrTrack_& instance) = 0;

            protected:
                SrrTrack_DataReaderView () {};
                ~SrrTrack_DataReaderView () {};
            private:
                SrrTrack_DataReaderView (const SrrTrack_DataReaderView &);
                SrrTrack_DataReaderView & operator = (const SrrTrack_DataReaderView &);
            };
        }

    }

}

#endif
