#ifndef _H_BFEC51F2642A96AC1115C05BD1F4D4DA_SrrDebug3_DCPS_H_
#define _H_BFEC51F2642A96AC1115C05BD1F4D4DA_SrrDebug3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrDebug3_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrDebug3_TypeSupportInterface;

            typedef SrrDebug3_TypeSupportInterface * SrrDebug3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug3_TypeSupportInterface> SrrDebug3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrDebug3_TypeSupportInterface> SrrDebug3_TypeSupportInterface_out;


            class SrrDebug3_DataWriter;

            typedef SrrDebug3_DataWriter * SrrDebug3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug3_DataWriter> SrrDebug3_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrDebug3_DataWriter> SrrDebug3_DataWriter_out;


            class SrrDebug3_DataReader;

            typedef SrrDebug3_DataReader * SrrDebug3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug3_DataReader> SrrDebug3_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrDebug3_DataReader> SrrDebug3_DataReader_out;


            class SrrDebug3_DataReaderView;

            typedef SrrDebug3_DataReaderView * SrrDebug3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug3_DataReaderView> SrrDebug3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrDebug3_DataReaderView> SrrDebug3_DataReaderView_out;

            struct SrrDebug3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrDebug3_, struct SrrDebug3_Seq_uniq_> SrrDebug3_Seq;
            typedef DDS_DCPSSequence_var < SrrDebug3_Seq> SrrDebug3_Seq_var;
            typedef DDS_DCPSSequence_out < SrrDebug3_Seq> SrrDebug3_Seq_out;

            class  SrrDebug3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrDebug3_TypeSupportInterface_ptr _ptr_type;
                typedef SrrDebug3_TypeSupportInterface_var _var_type;

                static SrrDebug3_TypeSupportInterface_ptr _duplicate (SrrDebug3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrDebug3_TypeSupportInterface () {};
                ~SrrDebug3_TypeSupportInterface () {};
            private:
                SrrDebug3_TypeSupportInterface (const SrrDebug3_TypeSupportInterface &);
                SrrDebug3_TypeSupportInterface & operator = (const SrrDebug3_TypeSupportInterface &);
            };

            class  SrrDebug3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrDebug3_DataWriter_ptr _ptr_type;
                typedef SrrDebug3_DataWriter_var _var_type;

                static SrrDebug3_DataWriter_ptr _duplicate (SrrDebug3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrDebug3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrDebug3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrDebug3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrDebug3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrDebug3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrDebug3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrDebug3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrDebug3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrDebug3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrDebug3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrDebug3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug3_& instance_data) = 0;

            protected:
                SrrDebug3_DataWriter () {};
                ~SrrDebug3_DataWriter () {};
            private:
                SrrDebug3_DataWriter (const SrrDebug3_DataWriter &);
                SrrDebug3_DataWriter & operator = (const SrrDebug3_DataWriter &);
            };

            class  SrrDebug3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrDebug3_DataReader_ptr _ptr_type;
                typedef SrrDebug3_DataReader_var _var_type;

                static SrrDebug3_DataReader_ptr _duplicate (SrrDebug3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug3_& instance) = 0;

            protected:
                SrrDebug3_DataReader () {};
                ~SrrDebug3_DataReader () {};
            private:
                SrrDebug3_DataReader (const SrrDebug3_DataReader &);
                SrrDebug3_DataReader & operator = (const SrrDebug3_DataReader &);
            };

            class  SrrDebug3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrDebug3_DataReaderView_ptr _ptr_type;
                typedef SrrDebug3_DataReaderView_var _var_type;

                static SrrDebug3_DataReaderView_ptr _duplicate (SrrDebug3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug3_& instance) = 0;

            protected:
                SrrDebug3_DataReaderView () {};
                ~SrrDebug3_DataReaderView () {};
            private:
                SrrDebug3_DataReaderView (const SrrDebug3_DataReaderView &);
                SrrDebug3_DataReaderView & operator = (const SrrDebug3_DataReaderView &);
            };
        }

    }

}

#endif
