#ifndef _H_782336EC760E5D3A130AB6861B6B1F66_SrrDebug4__H_
#define _H_782336EC760E5D3A130AB6861B6B1F66_SrrDebug4__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SrrDebug4_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean timer_create_error_;
                ::DDS::Boolean thread_create_error_;
                ::DDS::Boolean arm_calibration_error_;
                ::DDS::Boolean spi_fee_error_;
                ::DDS::Boolean spi_comm_error_;
                ::DDS::Boolean socket_write_error_;
                ::DDS::Boolean dsp_cal_obsolete_62_error_;
                ::DDS::Boolean socket_read_error_;
                ::DDS::Boolean socket_init_error_;
                ::DDS::Boolean signal_wait_error_;
                ::DDS::Boolean signal_send_error_;
                ::DDS::Boolean signal_create_error_;
                ::DDS::Boolean shared_mem_write_error_;
                ::DDS::Boolean shared_mem_read_error_;
                ::DDS::Boolean shared_mem_config_error_;
                ::DDS::Boolean share_mem_init_error_;
                ::DDS::Boolean ram_test_error_;
                ::DDS::Boolean num_errors_;
                ::DDS::Boolean mmap_memory_error_;
                ::DDS::Boolean isr_attach_error_;
                ::DDS::Boolean ipc_drv_write_error_;
                ::DDS::Boolean ipc_drv_trigger_error_;
                ::DDS::Boolean ipc_drv_sync_error_;
                ::DDS::Boolean ipc_drv_read_error_;
                ::DDS::Boolean ipc_drv_init_error_;
                ::DDS::Boolean interrupt_enable_error_;
                ::DDS::Boolean hil_format_error_;
                ::DDS::Boolean flash_filesystem_error_;
                ::DDS::Boolean error_none_;
                ::DDS::Boolean dsp_load_read_error_;
                ::DDS::Boolean dsp_load_open_error_;
                ::DDS::Boolean dsp_load_address_error_;
                ::DDS::Boolean dsp_isp_write_error_;
                ::DDS::Boolean dsp_ipc_read_error_;
                ::DDS::Boolean dsp_ipc_init_;
                ::DDS::Boolean dsp_init_error_;
                ::DDS::Boolean dsp_drv_start_error_;
                ::DDS::Boolean dsp_drv_load_error_;
                ::DDS::Boolean dsp_drv_init_error_;
                ::DDS::Boolean dsp_drv_init2_error_;
                ::DDS::Boolean dsp_drv_init1_error_;
                ::DDS::Boolean dsp_calibration_error_;
                ::DDS::Boolean can_xmt_error_;
                ::DDS::Boolean can_rcv_error_;
                ::DDS::Boolean can_hardware_error_;
                ::DDS::Boolean always_true_;
            };

            typedef DDS_DCPSStruct_var<SrrDebug4_> SrrDebug4__var;
            typedef DDS_DCPSStruct_out < SrrDebug4_> SrrDebug4__out;

        }

    }

}

#endif /* _H_782336EC760E5D3A130AB6861B6B1F66_SrrDebug4__H_ */
