#ifndef _H_782336EC760E5D3A130AB6861B6B1F66_SrrDebug4_DCPS_H_
#define _H_782336EC760E5D3A130AB6861B6B1F66_SrrDebug4_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrDebug4_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrDebug4_TypeSupportInterface;

            typedef SrrDebug4_TypeSupportInterface * SrrDebug4_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug4_TypeSupportInterface> SrrDebug4_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrDebug4_TypeSupportInterface> SrrDebug4_TypeSupportInterface_out;


            class SrrDebug4_DataWriter;

            typedef SrrDebug4_DataWriter * SrrDebug4_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug4_DataWriter> SrrDebug4_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrDebug4_DataWriter> SrrDebug4_DataWriter_out;


            class SrrDebug4_DataReader;

            typedef SrrDebug4_DataReader * SrrDebug4_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug4_DataReader> SrrDebug4_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrDebug4_DataReader> SrrDebug4_DataReader_out;


            class SrrDebug4_DataReaderView;

            typedef SrrDebug4_DataReaderView * SrrDebug4_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrDebug4_DataReaderView> SrrDebug4_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrDebug4_DataReaderView> SrrDebug4_DataReaderView_out;

            struct SrrDebug4_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrDebug4_, struct SrrDebug4_Seq_uniq_> SrrDebug4_Seq;
            typedef DDS_DCPSSequence_var < SrrDebug4_Seq> SrrDebug4_Seq_var;
            typedef DDS_DCPSSequence_out < SrrDebug4_Seq> SrrDebug4_Seq_out;

            class  SrrDebug4_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrDebug4_TypeSupportInterface_ptr _ptr_type;
                typedef SrrDebug4_TypeSupportInterface_var _var_type;

                static SrrDebug4_TypeSupportInterface_ptr _duplicate (SrrDebug4_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug4_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug4_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug4_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug4_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrDebug4_TypeSupportInterface () {};
                ~SrrDebug4_TypeSupportInterface () {};
            private:
                SrrDebug4_TypeSupportInterface (const SrrDebug4_TypeSupportInterface &);
                SrrDebug4_TypeSupportInterface & operator = (const SrrDebug4_TypeSupportInterface &);
            };

            class  SrrDebug4_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrDebug4_DataWriter_ptr _ptr_type;
                typedef SrrDebug4_DataWriter_var _var_type;

                static SrrDebug4_DataWriter_ptr _duplicate (SrrDebug4_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug4_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug4_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrDebug4_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrDebug4_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrDebug4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrDebug4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrDebug4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrDebug4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrDebug4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrDebug4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrDebug4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrDebug4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrDebug4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug4_& instance_data) = 0;

            protected:
                SrrDebug4_DataWriter () {};
                ~SrrDebug4_DataWriter () {};
            private:
                SrrDebug4_DataWriter (const SrrDebug4_DataWriter &);
                SrrDebug4_DataWriter & operator = (const SrrDebug4_DataWriter &);
            };

            class  SrrDebug4_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrDebug4_DataReader_ptr _ptr_type;
                typedef SrrDebug4_DataReader_var _var_type;

                static SrrDebug4_DataReader_ptr _duplicate (SrrDebug4_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug4_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug4_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug4_& instance) = 0;

            protected:
                SrrDebug4_DataReader () {};
                ~SrrDebug4_DataReader () {};
            private:
                SrrDebug4_DataReader (const SrrDebug4_DataReader &);
                SrrDebug4_DataReader & operator = (const SrrDebug4_DataReader &);
            };

            class  SrrDebug4_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrDebug4_DataReaderView_ptr _ptr_type;
                typedef SrrDebug4_DataReaderView_var _var_type;

                static SrrDebug4_DataReaderView_ptr _duplicate (SrrDebug4_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrDebug4_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrDebug4_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrDebug4_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrDebug4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrDebug4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrDebug4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrDebug4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrDebug4_& instance) = 0;

            protected:
                SrrDebug4_DataReaderView () {};
                ~SrrDebug4_DataReaderView () {};
            private:
                SrrDebug4_DataReaderView (const SrrDebug4_DataReaderView &);
                SrrDebug4_DataReaderView & operator = (const SrrDebug4_DataReaderView &);
            };
        }

    }

}

#endif
