#ifndef _H_A6D1A0B95CC9FD78EB46295545758A40_SrrStatus2__H_
#define _H_A6D1A0B95CC9FD78EB46295545758A40_SrrStatus2__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SrrStatus2_Constants
            {
                const ::DDS::Octet CAN_TX_ALIGNMENT_STATUS_UNKNOWN_ = 0;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATUS_CONVERGED_ = 1;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATUS_FAILED_ = 2;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATUS_RESERVED_ = 3;

            }

            struct  SrrStatus2_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet can_tx_alignment_status_;
                ::DDS::Boolean can_tx_comm_error_;
                ::DDS::Boolean can_tx_steering_angle_sign_;
                ::DDS::Float can_tx_yaw_rate_bias_;
                ::DDS::Float can_tx_veh_spd_comp_factor_;
                ::DDS::UShort can_tx_sw_version_dsp_;
                ::DDS::Short can_tx_temperature_;
                ::DDS::Boolean can_tx_range_perf_error_;
                ::DDS::Boolean can_tx_overheat_error_;
                ::DDS::Boolean can_tx_internal_error_;
                ::DDS::Boolean can_tx_xcvr_operational_;
                ::DDS::UShort can_tx_steering_angle_;
                ::DDS::Octet can_tx_rolling_count_2_;
            };

            typedef DDS_DCPSStruct_var<SrrStatus2_> SrrStatus2__var;
            typedef DDS_DCPSStruct_out < SrrStatus2_> SrrStatus2__out;

        }

    }

}

#endif /* _H_A6D1A0B95CC9FD78EB46295545758A40_SrrStatus2__H_ */
