#ifndef _H_A6D1A0B95CC9FD78EB46295545758A40_SrrStatus2_DCPS_H_
#define _H_A6D1A0B95CC9FD78EB46295545758A40_SrrStatus2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrStatus2_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrStatus2_TypeSupportInterface;

            typedef SrrStatus2_TypeSupportInterface * SrrStatus2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus2_TypeSupportInterface> SrrStatus2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrStatus2_TypeSupportInterface> SrrStatus2_TypeSupportInterface_out;


            class SrrStatus2_DataWriter;

            typedef SrrStatus2_DataWriter * SrrStatus2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus2_DataWriter> SrrStatus2_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrStatus2_DataWriter> SrrStatus2_DataWriter_out;


            class SrrStatus2_DataReader;

            typedef SrrStatus2_DataReader * SrrStatus2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus2_DataReader> SrrStatus2_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrStatus2_DataReader> SrrStatus2_DataReader_out;


            class SrrStatus2_DataReaderView;

            typedef SrrStatus2_DataReaderView * SrrStatus2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus2_DataReaderView> SrrStatus2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrStatus2_DataReaderView> SrrStatus2_DataReaderView_out;

            struct SrrStatus2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrStatus2_, struct SrrStatus2_Seq_uniq_> SrrStatus2_Seq;
            typedef DDS_DCPSSequence_var < SrrStatus2_Seq> SrrStatus2_Seq_var;
            typedef DDS_DCPSSequence_out < SrrStatus2_Seq> SrrStatus2_Seq_out;

            class  SrrStatus2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrStatus2_TypeSupportInterface_ptr _ptr_type;
                typedef SrrStatus2_TypeSupportInterface_var _var_type;

                static SrrStatus2_TypeSupportInterface_ptr _duplicate (SrrStatus2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrStatus2_TypeSupportInterface () {};
                ~SrrStatus2_TypeSupportInterface () {};
            private:
                SrrStatus2_TypeSupportInterface (const SrrStatus2_TypeSupportInterface &);
                SrrStatus2_TypeSupportInterface & operator = (const SrrStatus2_TypeSupportInterface &);
            };

            class  SrrStatus2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrStatus2_DataWriter_ptr _ptr_type;
                typedef SrrStatus2_DataWriter_var _var_type;

                static SrrStatus2_DataWriter_ptr _duplicate (SrrStatus2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrStatus2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrStatus2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus2_& instance_data) = 0;

            protected:
                SrrStatus2_DataWriter () {};
                ~SrrStatus2_DataWriter () {};
            private:
                SrrStatus2_DataWriter (const SrrStatus2_DataWriter &);
                SrrStatus2_DataWriter & operator = (const SrrStatus2_DataWriter &);
            };

            class  SrrStatus2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrStatus2_DataReader_ptr _ptr_type;
                typedef SrrStatus2_DataReader_var _var_type;

                static SrrStatus2_DataReader_ptr _duplicate (SrrStatus2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus2_& instance) = 0;

            protected:
                SrrStatus2_DataReader () {};
                ~SrrStatus2_DataReader () {};
            private:
                SrrStatus2_DataReader (const SrrStatus2_DataReader &);
                SrrStatus2_DataReader & operator = (const SrrStatus2_DataReader &);
            };

            class  SrrStatus2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrStatus2_DataReaderView_ptr _ptr_type;
                typedef SrrStatus2_DataReaderView_var _var_type;

                static SrrStatus2_DataReaderView_ptr _duplicate (SrrStatus2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus2_& instance) = 0;

            protected:
                SrrStatus2_DataReaderView () {};
                ~SrrStatus2_DataReaderView () {};
            private:
                SrrStatus2_DataReaderView (const SrrStatus2_DataReaderView &);
                SrrStatus2_DataReaderView & operator = (const SrrStatus2_DataReaderView &);
            };
        }

    }

}

#endif
