#ifndef _H_BC9DAA57221BAC4DB255319F0CF71DC0_SrrStatus3__H_
#define _H_BC9DAA57221BAC4DB255319F0CF71DC0_SrrStatus3__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SrrStatus3_Constants
            {
                const ::DDS::Octet CAN_TX_ALIGNMENT_STATE_OFF_ = 0;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATE_INIT_ = 1;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATE_AUTOMATIC_ALIGNMENT_ = 2;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATE_FACTORY_ALIGNMENT_ = 3;

                const ::DDS::Octet CAN_TX_ALIGNMENT_STATE_SERVICE_ALIGNMENT_ = 4;

            }

            struct  SrrStatus3_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet can_tx_alignment_state_;
                ::DDS::Octet can_tx_interface_ver_minor_;
                ::DDS::ULong can_tx_sw_version_arm_;
                ::DDS::Octet can_tx_hw_version_;
                ::DDS::Octet can_tx_interface_version_;
                ::DDS::ULong can_tx_serial_num_;
            };

            typedef DDS_DCPSStruct_var<SrrStatus3_> SrrStatus3__var;
            typedef DDS_DCPSStruct_out < SrrStatus3_> SrrStatus3__out;

        }

    }

}

#endif /* _H_BC9DAA57221BAC4DB255319F0CF71DC0_SrrStatus3__H_ */
