#ifndef _H_F959F26EBAAA6F166DFDE80EF970A0AD_SrrStatus4_DCPS_H_
#define _H_F959F26EBAAA6F166DFDE80EF970A0AD_SrrStatus4_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SrrStatus4_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SrrStatus4_TypeSupportInterface;

            typedef SrrStatus4_TypeSupportInterface * SrrStatus4_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus4_TypeSupportInterface> SrrStatus4_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SrrStatus4_TypeSupportInterface> SrrStatus4_TypeSupportInterface_out;


            class SrrStatus4_DataWriter;

            typedef SrrStatus4_DataWriter * SrrStatus4_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus4_DataWriter> SrrStatus4_DataWriter_var;
            typedef DDS_DCPSInterface_out < SrrStatus4_DataWriter> SrrStatus4_DataWriter_out;


            class SrrStatus4_DataReader;

            typedef SrrStatus4_DataReader * SrrStatus4_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus4_DataReader> SrrStatus4_DataReader_var;
            typedef DDS_DCPSInterface_out < SrrStatus4_DataReader> SrrStatus4_DataReader_out;


            class SrrStatus4_DataReaderView;

            typedef SrrStatus4_DataReaderView * SrrStatus4_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SrrStatus4_DataReaderView> SrrStatus4_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SrrStatus4_DataReaderView> SrrStatus4_DataReaderView_out;

            struct SrrStatus4_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SrrStatus4_, struct SrrStatus4_Seq_uniq_> SrrStatus4_Seq;
            typedef DDS_DCPSSequence_var < SrrStatus4_Seq> SrrStatus4_Seq_var;
            typedef DDS_DCPSSequence_out < SrrStatus4_Seq> SrrStatus4_Seq_out;

            class  SrrStatus4_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SrrStatus4_TypeSupportInterface_ptr _ptr_type;
                typedef SrrStatus4_TypeSupportInterface_var _var_type;

                static SrrStatus4_TypeSupportInterface_ptr _duplicate (SrrStatus4_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus4_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus4_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus4_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus4_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SrrStatus4_TypeSupportInterface () {};
                ~SrrStatus4_TypeSupportInterface () {};
            private:
                SrrStatus4_TypeSupportInterface (const SrrStatus4_TypeSupportInterface &);
                SrrStatus4_TypeSupportInterface & operator = (const SrrStatus4_TypeSupportInterface &);
            };

            class  SrrStatus4_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SrrStatus4_DataWriter_ptr _ptr_type;
                typedef SrrStatus4_DataWriter_var _var_type;

                static SrrStatus4_DataWriter_ptr _duplicate (SrrStatus4_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus4_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus4_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SrrStatus4_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SrrStatus4_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SrrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SrrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SrrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SrrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SrrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SrrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SrrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SrrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SrrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus4_& instance_data) = 0;

            protected:
                SrrStatus4_DataWriter () {};
                ~SrrStatus4_DataWriter () {};
            private:
                SrrStatus4_DataWriter (const SrrStatus4_DataWriter &);
                SrrStatus4_DataWriter & operator = (const SrrStatus4_DataWriter &);
            };

            class  SrrStatus4_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SrrStatus4_DataReader_ptr _ptr_type;
                typedef SrrStatus4_DataReader_var _var_type;

                static SrrStatus4_DataReader_ptr _duplicate (SrrStatus4_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus4_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus4_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus4_& instance) = 0;

            protected:
                SrrStatus4_DataReader () {};
                ~SrrStatus4_DataReader () {};
            private:
                SrrStatus4_DataReader (const SrrStatus4_DataReader &);
                SrrStatus4_DataReader & operator = (const SrrStatus4_DataReader &);
            };

            class  SrrStatus4_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SrrStatus4_DataReaderView_ptr _ptr_type;
                typedef SrrStatus4_DataReaderView_var _var_type;

                static SrrStatus4_DataReaderView_ptr _duplicate (SrrStatus4_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SrrStatus4_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SrrStatus4_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SrrStatus4_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SrrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SrrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SrrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SrrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SrrStatus4_& instance) = 0;

            protected:
                SrrStatus4_DataReaderView () {};
                ~SrrStatus4_DataReaderView () {};
            private:
                SrrStatus4_DataReaderView (const SrrStatus4_DataReaderView &);
                SrrStatus4_DataReaderView & operator = (const SrrStatus4_DataReaderView &);
            };
        }

    }

}

#endif
