#ifndef _H_F53A1A7F4AD96DE74437A0800BC4C41C_SrrTrack__H_
#define _H_F53A1A7F4AD96DE74437A0800BC4C41C_SrrTrack__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_srr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SrrTrack_Constants
            {
                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_SUSPECT_DETECTION_ = 0;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_1_ = 1;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_2_ = 2;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_3_ = 3;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_4_ = 4;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_5_ = 5;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_6_ = 6;

                const ::DDS::Octet CAN_TX_DETECT_VALID_LEVEL_LEVEL_7_ = 7;

                const ::DDS::Boolean CAN_TX_DETECT_STATUS_NO_DATA_ = FALSE;

                const ::DDS::Boolean CAN_TX_DETECT_STATUS_VALID_DATA_PRESENT_ = TRUE;

            }

            struct  SrrTrack_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet can_tx_detect_valid_level_;
                ::DDS::Boolean can_tx_detect_status_;
                ::DDS::Float can_tx_detect_range_rate_;
                ::DDS::Float can_tx_detect_range_;
                ::DDS::Float can_tx_detect_angle_;
                ::DDS::Float can_tx_detect_amplitude_;
            };

            typedef DDS_DCPSStruct_var<SrrTrack_> SrrTrack__var;
            typedef DDS_DCPSStruct_out < SrrTrack_> SrrTrack__out;

        }

    }

}

#endif /* _H_F53A1A7F4AD96DE74437A0800BC4C41C_SrrTrack__H_ */
